﻿using System;
using System.Collections.Generic;

namespace RestfulService
{
  public class EmployeeData
  {
    private static readonly EmployeeData _instance = new EmployeeData();

    private EmployeeData() { }

    public static EmployeeData Instance
    {
      get
      {
        return _instance;
      }
    }

    private readonly List<Employee> _empList = new List<Employee>()
        {
            new Employee() { Id  = 1, FirstName = "Petr", LastName = "Novák", JoinDate=new DateTime(2010,7, 21), Age=30,Salary=10000,Designation="Software Engineer"},
            new Employee() { Id = 2, FirstName = "Jan", LastName = "Novák", JoinDate=new DateTime(2009,6,8), Age=35,Salary=10000,Designation="Senior Software Engineer"},    
            new Employee() { Id = 3, FirstName = "Lukáš", LastName = "Novák", JoinDate=new DateTime(2008,3,5), Age=39,Salary=10000,Designation="Projet Manager"},  
            new Employee() { Id = 4, FirstName = "Tomáš", LastName = "Novák", JoinDate=new DateTime(2010, 5,1), Age=56,Salary=10000,Designation="Projet Manager"},
        };

    public List<Employee> EmployeeList
    {
      get
      {
        return _empList;
      }
    }

    public void Update(Employee updEmployee)
    {
      Employee existing = _empList.Find(p => p.Id == updEmployee.Id);

      if (existing == null)
        throw new KeyNotFoundException("Specified Employee cannot be found");

      existing.FirstName = updEmployee.FirstName;
      existing.LastName = updEmployee.LastName;
      existing.Age = updEmployee.Age;
    }

    public void Delete(int empid)
    {
      Employee existing = _empList.Find(p => p.Id == empid);
      _empList.Remove(existing);
    }
    public void Add(Employee newEmployee)
    {
      _empList.Add(new Employee
      {
        Id = newEmployee.Id,
        FirstName = newEmployee.FirstName,
        LastName = newEmployee.LastName,
        Age = newEmployee.Age,
        JoinDate = DateTime.Now,
        Designation = newEmployee.Designation,
        Salary = newEmployee.Salary
      });
    }
  }
}
