﻿using System.Collections.Generic;
using System.ServiceModel;
using System.ServiceModel.Web;

namespace RestfulService
{
  [ServiceContract]
  public interface IRestfulService
  {
    [WebGet(UriTemplate = "Employee")]
    [OperationContract]
    List<Employee> GetAllEmployeeDetails();

    [WebGet(UriTemplate = "Employee?id={id}")]
    [OperationContract]
    Employee GetEmployee(int id);

    [WebInvoke(Method = "POST", UriTemplate = "EmployeePOST")]
    [OperationContract]
    void AddEmployee(Employee newEmp);

    [WebInvoke(Method = "PUT", UriTemplate = "EmployeePUT")]
    [OperationContract]
    void UpdateEmployee(Employee newEmp);

    [WebInvoke(Method = "DELETE", UriTemplate = "Employee/Delete?id={id}")]
    [OperationContract]
    void DeleteEmployee(int id);
  }
}
