﻿using System;
using System.ServiceModel.Web;
using RestfulService;

namespace RestfulServiceClient
{
  class Program
  {
    static void Main(string[] args)
    {
      var uri = new Uri("http://localhost.fiddler/CoolService");
      var channelFactory = new WebChannelFactory<IRestfulService>(uri);
      IRestfulService client = channelFactory.CreateChannel();

      ShowEmployees(client);

      client.AddEmployee(new Employee()
      {
        Id = 100,
        FirstName = "John",
        LastName = "Doe",
        JoinDate = new DateTime(2010, 7, 24),
        Age = 34,
        Salary = 10000,
        Designation = "Software Engineer"
      });

      Console.WriteLine(Environment.NewLine + "******************After adding new user ****************" + Environment.NewLine);

      ShowEmployees(client);

      client.DeleteEmployee(1);

      Console.WriteLine(Environment.NewLine + "******************After removing user 1 ****************" + Environment.NewLine);

      ShowEmployees(client);

      Console.ReadLine();
    }

    private static void ShowEmployees(IRestfulService client)
    {
      foreach (Employee employee in client.GetAllEmployeeDetails())
      {
        ShowEmployeeInConsole(employee);
      }
    }

    private static void ShowEmployeeInConsole(Employee e)
    {
      Console.WriteLine("Id:{0}, Name:{1} {2}", e.Id, e.FirstName, e.LastName);
    }
  }
}
